﻿-- Author      : Nogarder
-- Create Date : 2014/12/1 4:53:58
--use for rotate texture
--macro for rotate coordinate
local RS_TextureManager_Rotation=function(x,y,angle)
	local ca=cos(angle)--floor(cos(angle)*1000)/1000
	local sa=sin(angle)--floor(sin(angle)*1000)/1000
	return x*ca-y*sa,x*sa+y*ca
end
--rotate texture
--function for texture rotation
local RS_TextureManager_SetTextureRotation=function(texture,left,right,top,bottom,angle)
	local centerx=(left+right)/2
	local centery=(top+bottom)/2

	local dleft=left-centerx
	local dright=right-centerx
	local dtop=top-centery
	local dbottom=bottom-centery
	
	local tlx,tly=RS_TextureManager_Rotation(dleft,dtop,angle)
	local blx,bly=RS_TextureManager_Rotation(dleft,dbottom,angle)
	local trx,try=RS_TextureManager_Rotation(dright,dtop,angle)
	local brx,bry=RS_TextureManager_Rotation(dright,dbottom,angle)

	tlx=tlx+centerx
	tly=tly+centery
	blx=blx+centerx
	bly=bly+centery
	trx=trx+centerx
	try=try+centery
	brx=brx+centerx
	bry=bry+centery

	texture:SetTexCoord(tlx,tly,blx,bly,trx,try,brx,bry)
end
--
RS.SetTextureRotation=function(texture,angle,scale)
	scale=scale or 1
	local dleft=-0.5*scale
	local dright=0.5*scale
	local dtop=-0.5*scale
	local dbottom=0.5*scale
	
	local tlx,tly=RS_TextureManager_Rotation(dleft,dtop,angle)
	local blx,bly=RS_TextureManager_Rotation(dleft,dbottom,angle)
	local trx,try=RS_TextureManager_Rotation(dright,dtop,angle)
	local brx,bry=RS_TextureManager_Rotation(dright,dbottom,angle)

	tlx=tlx+0.5
	tly=tly+0.5
	blx=blx+0.5
	bly=bly+0.5
	trx=trx+0.5
	try=try+0.5
	brx=brx+0.5
	bry=bry+0.5

	texture:SetTexCoord(tlx,tly,blx,bly,trx,try,brx,bry)
end
--
