-- Author      : Nogarder
-- Create Date : 2015/3/1 22:30:08

local table_insert=table.insert
	
local Localization=RS.Localization
local Tooltips=RS.Localization.Tooltips

local parent=RS.OptionsMain	
local main=RS.Template.CreateFrameWithBar(parent,nil,150,240,nil,nil,nil,parent)
main:Show()

main:HookScript("OnHide",function()
	parent:Hide()
end)


local listeditor=RS.Template.CreateListEditor(main.Frame,nil,150,240,main,30)

--script
local Refresh=function()
	local list={}
	for name,_ in pairs(RS_Profile) do
		table_insert(list,{
			Text=name,
			Value=name,
		})
	end
	RS.Template.UpdateListEditor(listeditor,list)
end

main.Frame:HookScript("OnShow",Refresh)

listeditor.RefreshFunc=Refresh

listeditor.OnCopyFunc=function(oldname,newname)
	RS_Profile[newname]=CopyTable(RS_Profile[oldname])
	RS.EventHandler.FireEvent(1,"RS_SettingUpdated")
end

listeditor.OnDeleteFunc=function(oldname)
	RS_Profile[oldname]=nil
	RS.EventHandler.FireEvent(1,"RS_SettingUpdated")
end
listeditor.OnRenameFunc=function(oldname,newname)
	RS_Profile[newname]=CopyTable(RS_Profile[oldname])
	RS_Profile[oldname]=nil
	RS.EventHandler.FireEvent(1,"RS_SettingUpdated")
end
listeditor.OnCreateFunc=function(newname)
	RS_Profile[newname]={}
	RS.EventHandler.FireEvent(1,"RS_SettingUpdated")
end
listeditor.OnClickFunc=function(name)
	--setup editor page
	RS.SetPage("SequenceEditor",main,name)
end

local ziped
main:HookScript("OnShow",function()
	ziped=false
end)
main.Minimizer:HookScript("OnMouseUp",function()
	if(ziped)then
		RS.RestorePages(main)
		ziped=false
	else
		RS.MinimizePages(main)
		ziped=true
	end
end)


RS.RegisterPage("MainPage",main)
RS.OptionsMainPage=main