﻿-- Author      : Nogarder
-- Create Date : 2014/12/16 12:09:42
local Localization=RS.Localization
local Tooltips=Localization.Tooltips
--create
local RS_Template_CheckBox_CheckChecked=function(checkbox,nocenter)
	if(checkbox.Checked)then
		checkbox.CheckerA:Show()
		if(checkbox.Liner)then
			checkbox.Liner:Show()
		end
	else
		checkbox.CheckerA:Hide()
		if(checkbox.Liner)then
			checkbox.Liner:Hide()
		end
	end
end
RS.Template.CreateCheckBox=function(parent,width,height,text,tooltips,nocenter)
	local checkbox=CreateFrame("Frame",nil,parent)
	--background
	RS.Template.CreateBackground(checkbox)
	--script
	checkbox:SetScript("OnEnter",function(checkbox)
		if(checkbox.Spellid)then
			GameTooltip:SetOwner(checkbox,"ANCHOR_RIGHT")
			GameTooltip:AddSpellByID(checkbox.Spellid)
			GameTooltip:SetFrameLevel(checkbox:GetFrameLevel()+3)
			GameTooltip:AddLine("Spell id"..": |cff00ff00"..checkbox.Spellid)
			GameTooltip:Show()
		end
	end)
	checkbox:SetScript("OnLeave",function(checkbox)
		if(checkbox.Spellid)then
			GameTooltip:Hide()
		end
	end)
	checkbox:SetScript("OnMouseUp",function(checkbox)
		if(checkbox.Checked)then
			checkbox.Checked=false
		else
			checkbox.Checked=true
		end
		RS_Template_CheckBox_CheckChecked(checkbox)
		--
		RS.RunFunc(checkbox.ShowTipText)
		RS.RunFunc(checkbox.OnValueUpdateFunc,checkbox)
	end)
	--label
	checkbox.Label=RS.Template.CreateText(checkbox,text)
	--
	if(not height)then
		height=checkbox.Label:GetHeight()+2
	end
	checkbox:SetHeight(height)
	if(nocenter)then
		checkbox.Label:SetPoint("LEFT",checkbox,"LEFT",height+2,0)
	else
		checkbox.Label:SetPoint("CENTER",checkbox,"CENTER",0,0)
	end

	if(not width)then
		if(text)then
			width=checkbox.Label:GetWidth()+4+height
		else
			width=10
		end
	end
	
	checkbox:SetWidth(width)
	--texture
	checkbox.Texture=checkbox:CreateTexture(nil,"ARTWORK")
	checkbox.Texture:SetPoint("TOPLEFT",checkbox,"TOPLEFT")
	checkbox.Texture:SetPoint("BOTTOMRIGHT",checkbox,"BOTTOMRIGHT")
	--
	local circle=RS.Template.CreateCircle(checkbox,height/3,2)
	circle:SetPoint("LEFT",checkbox,"LEFT",height/2,0)
	circle:Hide()
	checkbox.CheckerA=circle
	--show
	checkbox:Show()
	--
	RS.Template.SetTooltips(tooltips,checkbox)
	--return pointer
	return checkbox
end
--macro for disable checkbox
RS.Template.DisableCheckBox=function(checkbox)
	if(not checkbox.DisableLiner)then
		local texture=checkbox:CreateTexture(nil,"OVERLAY")
		texture:SetPoint("LEFT",checkbox,"LEFT",0,0)
		texture:SetPoint("RIGHT",checkbox,"RIGHT",0,0)
		texture:SetHeight(checkbox:GetHeight()/5)
		texture:SetTexture("Interface\\Addons\\NPA2_Options\\texture\\Liner")
		texture:Show()
		checkbox.DisableLiner=texture
	else
		checkbox.DisableLiner:Show()
	end
	checkbox.Disabled=true
end
--macro for enable checkbox
RS.Template.EnableCheckBox=function(checkbox)
	if(checkbox.DisableLiner)then
		checkbox.DisableLiner:Hide()
	end
	checkbox.Disabled=nil
end
--
RS.Template.SetCheckBox=function(checkbox,value)
	checkbox.Checked=value
	RS_Template_CheckBox_CheckChecked(checkbox)
end
--
RS.Template.SetCheckBoxSize=function(checkbox,width,height,atype)
	checkbox:SetWidth(width)
	checkbox:SetHeight(height)
	checkbox.CheckerA:SetPoint("LEFT",checkbox,"LEFT",height/2,0)
	RS.Template.SetCircleSize(checkbox.CheckerA,height*0.4)
	if(atype==1)then
		checkbox.Texture:ClearAllPoints()
		checkbox.Texture:SetPoint("LEFT",checkbox,"LEFT",height,0)
		checkbox.Texture:SetWidth(height)
		checkbox.Texture:SetHeight(height)
		--
		checkbox.Label:ClearAllPoints()
		checkbox.Label:SetPoint("LEFT",checkbox.Texture,"RIGHT",2,0)
	end
end
