-- Author      : Nogarder
-- Create Date : 2015/3/1 22:39:36

RS.Template.CreatePlayerGroup=function(parent)
	local frame=RS.Template.CreateFrame(parent)
	--
	frame.PlayerFrames={}
	frame.GroupCount=0

	frame.Index=""
	
	frame:HookScript("OnMouseUp",function(self,mousebutton)
		local str=parent.Name..self.Index..":"
		local playerframes=self.PlayerFrames
		--
		for i=1,self.GroupCount do
			local playerframe=playerframes[i]
			local playerdata=playerframe.PlayerData
			str=str.." "..playerdata.Name..":"
			for spellid,_ in pairs(playerdata.SelectedSpell)do
				local spellname=GetSpellInfo(spellid)
				str=str.."["..spellname.."]"
			end
			str=str.."  ,"
		end
		local channel
		if(mousebutton=="LeftButton")then
			if(IsInRaid())then
				channel="RAID"
			elseif(IsInGroup())then
				channel="PARTY"
			end
		else
			channel="RAID_WARNING"
		end
		
		SendChatMessage(str,channel)
	end)

	return frame
end

RS.Template.UpdatePlayerGroup=function(frame)
	local count=frame.GroupCount
	if(count==0)then
		return
	end
	local playerframes=frame.PlayerFrames
	local RS_Template_UpdatePlayerFrame=RS.Template.UpdatePlayerFrame
	if(frame.Vertical)then
		local width=frame:GetWidth()
		local height=frame:GetHeight()/count

		for i=1,count do
			local playerframe=playerframes[i]

			playerframe:SetWidth(width-5)
			playerframe:SetHeight(height-5)

			playerframe:ClearAllPoints()
			playerframe:SetPoint("TOPLEFT",frame,"TOPLEFT",2,(1-i)*height)

			RS.Template.SetPlayerFramePercent(playerframe,1)
			RS_Template_UpdatePlayerFrame(playerframe)
			playerframe:Show()
		end
		for i=count+1,table.getn(playerframes)do
			playerframes[i]:Hide()
		end
	else
		local width=frame:GetWidth()/count
		local height=frame:GetHeight()

		for i=1,count do
			local playerframe=playerframes[i]

			playerframe:SetWidth(width-5)
			playerframe:SetHeight(height-5)

			playerframe:ClearAllPoints()
			playerframe:SetPoint("TOPLEFT",frame,"TOPLEFT",(i-1)*width,-2)

			RS.Template.SetPlayerFramePercent(playerframe,1)
			RS_Template_UpdatePlayerFrame(playerframe)
			playerframe:Show()
		end
		for i=count+1,table.getn(playerframes)do
			playerframes[i]:Hide()
		end
	end
end

RS.Template.EnablePlayerGroupCoolDown=function(frame)
	local playerframes=frame.PlayerFrames
	for i=1,frame.GroupCount do
		RS.Template.StartCoolDownMonitor(playerframes[i].PlayerData,playerframes[i].CoolDownGroup)
	end
	for i=frame.GroupCount+1, table.getn(playerframes) do
		RS.Template.StopCoolDownMonitor(playerframes[i].PlayerData,playerframes[i].CoolDownGroup)
	end
end
RS.Template.DisablePlayerGroupCoolDown=function(frame)
	local playerframes=frame.PlayerFrames
	for i=1, table.getn(playerframes) do
		RS.Template.StopCoolDownMonitor(playerframes[i].PlayerData,playerframes[i].CoolDownGroup)
	end
end

RS.Template.SetPlayerGroup=function(frame,group,disablemouse,index)
	local RS_Template_SetPlayerFrame=RS.Template.SetPlayerFrame
	local playerframes=frame.PlayerFrames
	local enablemouse=not disablemouse

	local i=1
	for name,playerdata in pairs(group) do
		if(not playerframes[i])then
			playerframes[i]=RS.Template.CreatePlayerFrame(frame)
		end
		local playerframe=playerframes[i]
		--
		RS_Template_SetPlayerFrame(playerframe,name,playerdata,false)
		playerframe:Show()
		i=i+1
	end
	frame.GroupCount=i-1
	for j=i,table.getn(playerframes)	do
		playerframes[j]:Hide()
	end

	frame:EnableMouse(enablemouse)
	
	RS.Template.UpdatePlayerGroup(frame)

	frame.Index=index or ""
end